Windows多用户远程桌面----采用RDP Wrapper Library支持所有的Windows版本

杂货铺 专栏收录该内容
11 篇文章 1 订阅

 Windows10  2004版本版本已经支持!!!直接见本文最下面的更新!!!

 Windows10 1909版本已经支持!!!

       

说到要在非Windows Server版本上实现多用户远程桌面连接 ,我们都知道一个大名鼎鼎的软件RDP Wrapper Library,然而,我们又对这个软件了解多少呢?

有时候我们认为的问题,其实根本不是问题!

       为什么我要这么说?让我们一起看看这个大名鼎鼎的软件,RDP Wrapper Library它是开源的,所有秘密作者都没有保留,所有问题全部在GitHub上面写的清清楚楚,在这里感谢这些伟大的人!

       打开项目的GitHub(https://github.com/stascorp/rdpwrap/releases/tag/v1.6.2),首页写着最新的版本是v1.6.2,最近一次更新时间为2017年12月,现在已经2020年,难道这个项目中途夭折了?实际上没有,而是这个项目目前已经接近完美,最后一个版本,作者将软件进行了拆分,将核心模块和配置文件拆分独立出来了,通过修改配置文件,就可以让软件支持最新版本的Windows,并且配置文件的修改方法也录制了详细的视频放在了这个GItHub上面,只要有一个人更新了配置文件 ,并把它上传或者分享到GitHub上面,那么所有使用这个版本Windows的人都可以直接使用这个配置文件,多么方便啊!实际上,仔细看看这个项目的Issue,我们确实也是这么干的!共享万岁!正是这种优良的设计,所以作者才一直没有更新吧!

这个软件的原理是什么?(摘自该项目的GitHub官网,重要,这是本文的核心)

RDP Wrapper works as a layer between Service Control Manager and Terminal Services, so the original termsrv.dll file remains untouched. Also this method is very strong against Windows Update.

        简单来说,RDPWrapper 是在服务控制管理器和终端服务之间增加了一层,或者说,它类似一个管道,将服务控制管理器和终端服务连接起来,在这一层(管道)实现了并发RDP会话(多用户同时远程桌面),所以它让原始的termsrv.dll文件保持不变,不对其进行任何修改,从而保证Windows的稳定性,这种设计可以很好的应对Windows更新。

RDP Wrapper does not patch termsrv.dll, it loads termsrv with different parameters.

        RDPWrapper 不修改termsrv.dll,它用不同的参数加载termsrv.dll。

       所以我们的问题:对于某某版本的Windows想支持多用户远程桌面,经过搜索尝试下载了很多软件不行,RDPWrapper也不支持,怎么办?急,在线等!这个根本不是问题,首先,看看我们自己Windows的termsrv.dll的版本,然后到RDPWrapper的GitHub上面找对应版本的配置文件或者修改方法(你要相信肯定不只你一个人遇到这个问题),修改配置文件,运行RDPWrapper,OK!

 

配置文件如何更新?

先来看看配置文件是什么以及里面的内容是什么?

       在后面的详细步骤中的第二步(实际是第一步,下载软件不算步骤),需要先执行 install.bat安装RDPWrapper,会在C:\Program Files\RDP Wrapper下面生成2个文件:rdpwrap.dll(核心模块),rdpwrap.ini(配置文件),没错,这就是我们要修改的配置文件。

 

        OK!长话短说,速度速度!我直接讲。看看这个配置文件的内容,显目的PatchCode,显目的nop,jump,熟悉的edx,eax,全是汇编,x64和x86是什么更不用我来说了,点到即止。还有仔细看看[10.0.17763.1-SLInit]这部分内容,是不是明白了?

       好吧,好像什么都没有说,没有办法,要讲清楚,只有pull源码来讲,但是抱歉我暂时没有那么多时间,我菜得很,还有很多东西要学,上面最重要的东西已经提到了,感兴趣的朋友自己去pull源码分析吧,我就浅尝辄止了。

总结一下(以下内容未经深入分析源码,全是本人猜测,看看就行,不要当真,最重要的是,不要来找我验证,我无知啊!)

       如果我没有猜错的话,RDPWrapper将核心功能模块实现放在了rdpwrap.dll中,也就是软件原理里面提到了那一层(管道),采用Hook技术,通过加载配置文件rdpwrap.ini,Hook了termsrv.dll,从而实现其提到的:RDPWrapper 不修改termsrv.dll,它用不同的参数加载termsrv.dll,以及我前面提到的,软件拆分,将核心模块和配置文件拆分独立,通过修改配置文件rdpwrap.ini,就可以让软件支持最新版本的Windows。这涉及到汇编,Hook技术,Dll技术,我就不展开讲了。

所以,目前最重要的就是配置文件,其他的东西对我们不重要,我们来看看这段:

[10.0.17763.1-SLInit]             RDPWrapper能支持的termsrv.dll版本号
bInitialized.x86      =CD798      X86这是针对32位系统的配置
bServerSku.x86        =CD79C
lMaxUserSessions.x86  =CD7A0
bAppServerAllowed.x86 =CD7A8
bRemoteConnAllowed.x86=CD7AC
bMultimonAllowed.x86  =CD7B0
ulMaxDebugSessions.x86=CD7B4
bFUSEnabled.x86       =CD7B8

bInitialized.x64      =ECAB0      x64这是针对64位系统的配置
bServerSku.x64        =ECAB4
lMaxUserSessions.x64  =ECAB8
bAppServerAllowed.x64 =ECAC0
bRemoteConnAllowed.x64=ECAC4
bMultimonAllowed.x64  =ECAC8
ulMaxDebugSessions.x64=ECACC
bFUSEnabled.x64       =ECAD0

       是不是明白了?RDPWrapper支持哪些Windows版本的termsrv.dll(就是下面图片中那个讨厌的不支持not supported),就是看配置文件里面有没有类似上面这段代码,所以,问题清楚了,RDPWrapper不支持最新的Windows10 1909版本怎么办?上RDPWrapper的GitHub去Issue里面找,找到别人提供的和上面类似的配置代码或者配置文件,将它复制添加到我们自己计算机上面对应的配置文件rdpwrap.ini或者直接替换掉我们自己计算机里面的配置文件rdpwrap.ini,再重新执行一次 install.bat,OK了,下班了,各位朋友。

总体思路:

       首先搞清楚自己的计算机或者你要实现多用户同时远程桌面的计算机上面termsrv.dll版本(不要管你的计算机Windows是什么版本,RDPWrapper针对是termsrv.dll的版本),可以通过RDPWrapper软件中自带的RDPConf.exe软件直接检测,如果显示不支持not supported,那就说明当前配置文件不支持这个版本的termsrv.dll,上RDPWrapper的GitHub去Issue里面找,找到别人提供的和上面类似的配置代码或者配置文件,将它复制添加到我们自己计算机上面对应的配置文件rdpwrap.ini或者直接替换掉我们自己计算机里面的配置文件rdpwrap.ini,再重新执行一次 install.bat,再检测一下,OK了。

 

 

 

详细步骤:(以本人计算机上面的termsrv.dll的版本[10.0.17763.1-SLInit]为例子)

1.下载RDPWrap-v1.6.2.zip,解压,里面包含如下文件,每个文件的作用参考下面的表格。

文件名描述
RDPWSTST.EXERDP包装库安装程序/卸载程序
RDPCHECK.EXE本地RDP检查器(可以检查RDP正在工作)
RDPCON.EXERDP包装器配置

install.bat

快速安装批处理文件
uninstall.bat快速卸载批处理文件
update.bat快速更新批处理文件

 

2.执行 install.bat,会在C:\Program Files\RDP Wrapper下面生成2个文件:rdpwrap.dll(核心模块),rdpwrap.ini(配置文件),没错,这就是我们要修改的配置文件。

 

3.执行RDPWrapper软件中自带的RDPConf.exe软件直接检测,如果显示全绿,那么恭喜你,RDPWrapper支持你当前计算机的termsrv.dll版本,如果显示不支持not supported,那就说明当前配置文件不支持这个版本的termsrv.dll,本人这里显示不支持。

4.上RDPWrapper的GitHub去Issue里面去搜索对应的版本号,找到别人提供的支持[10.0.17763.1]版本的配置代码,添加到位于C:\Program Files\RDP Wrapper\rdpwrap.ini下面rdpwrap.ini配置文件中。当然如果别人提供的是新版本的配置文件,直接替换即可。提醒一下,配置代码的格式一定要正确,请参考前面的分析部分。

本例中,在GitHub中找到了如下配置代码,将它添加到rdpwrap.ini配置文件中。

[10.0.17763.1-SLInit]
bInitialized.x86      =CD798
bServerSku.x86        =CD79C
lMaxUserSessions.x86  =CD7A0
bAppServerAllowed.x86 =CD7A8
bRemoteConnAllowed.x86=CD7AC
bMultimonAllowed.x86  =CD7B0
ulMaxDebugSessions.x86=CD7B4
bFUSEnabled.x86       =CD7B8

bInitialized.x64      =ECAB0
bServerSku.x64        =ECAB4
lMaxUserSessions.x64  =ECAB8
bAppServerAllowed.x64 =ECAC0
bRemoteConnAllowed.x64=ECAC4
bMultimonAllowed.x64  =ECAC8
ulMaxDebugSessions.x64=ECACC
bFUSEnabled.x64       =ECAD0

5.再次运行RDPConf.exe检测是否支持,可以看到已经支持了。

1024.还没有完,还有一些计算机本地策略需要修改,以及一些问题和优化,比如连接时提示最大连接数量?如何优化远程桌面性能实现自动注销登出用户?还有最基本的如何创建用户?如何替换系统文件termsrv.dll?几乎你能遇到的问题全部都详细写了。请看我另外一篇的博客!(https://blog.csdn.net/u010804317/article/details/100055558

6666.今年运气不错,那么问题来了,有朋友说我是吹神,天天吹牛逼,问我,最新的Windows版本,版本新到RDPWrapper的GitHub上面都还没有人更新配置文件,怎么办?一直等吗?对此,我只想说,这个问题充钱就能解决!

直接丢王炸给各位

       想想Windows一贯以来的一个优点,向下兼容!get到了吗?远程桌面模块已经运行这么多年了,Bug和缺陷其实早就修复完了,最新的Windows中的termsrv.dll和上一个版本,甚至上上个版本的termsrv.dll基本上完全相同,也就是说,我们完全可以用上一个低版本的termsrv.dll替换本机上面最新termsrv.dll,当然凡事得有个度,物极必反,两个文件的版本还是不要相差的太大。只要替换成低版本后远程桌面能正常运行即可,而低版本GitHub上面肯定有人已经解决了,所以问题得到解决。详细过程请看我另外一篇的博客!(https://blog.csdn.net/u010804317/article/details/100055558).

 

                                  各位大佬,这个方法6不6?

 

       因为本方法毕竟替换了termsrv.dll,可能造成系统不稳定!注意!注意!注意!由此造成的任何损失本人概不负责!

       注意!这是另类方法!不是正道!标准简单的方法参见上面提到的博文!直接使用RDPWrap这个软件,执行bat文件,自动打入破解补丁即可完美解决,非常简单。

 

1.最后是大家喜闻乐见的成功截图!至于前面提到的直接通过RDPWrapper,点点鼠标就能成功的截图就不发了,没意思的,太简单了。

       注意看细节部分,第一张图,windows已经升级到最新的Windows10 1909版本,这个版本的termsrv.dll为18362.267,时间为2020/01/03,我直接替换成上一个Windows版本的termsrv.dll也就是Windows10 1809版本中的1773.1,时间为2018/09/15,看第二张图,OK的!使用起来也没有问题,稳如老狗!

 

2.关于更新支持Win10 2004版本的成功截图

       注意看细节部分,windows已经升级到最新的Windows10 2004版本,这个版本的termsrv.dll为10.0.19041.84,时间为2020/05/31,稳如老狗!

      

8888.关于相关资源问题,RDPWrapper软件和最新的支持最新Windows版本的配置文件rdpwrap.ini,请在GitHub官网(https://github.com/stascorp/rdpwrap/releases/tag/v1.6.2)下载。如果你需要termsrv.dll[10.0.17763.1]版本和最新的rdpwrap.ini请评论私信我,谢谢~!

评论 121 您还未登录,请先 登录 后发表或查看评论
©️2022 CSDN 皮肤主题:编程工作室 设计师:CSDN官方博客 返回首页

打赏作者

知贵待缘

你的鼓励将是我创作的最大动力

¥2 ¥4 ¥6 ¥10 ¥20
输入1-500的整数
余额支付 (余额:-- )
扫码支付
扫码支付:¥2
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值